<a href="CODE_OF_CONDUCT.en.md"><img src="images/en.svg" valign="top" align="right"/></a>
<a href="CODE_OF_CONDUCT.md"><img src="images/de.svg" valign="top" align="right"/></a>
<!--[![Version][version-badge]][version-url]-->
[![License][license-badge]][license-url]
<!--
[![Bugs][bugs-badge]][bugs-url]
-->

[![Logo][logo]][project-url]

### Code of Conduct

#### Our Pledge

The heart of this community is people. We put people first and do our best to recognize, appreciate and respect the diversity of our global contributors. This community welcomes contributions from everyone who shares our goals and wants to contribute in a healthy and constructive manner within our community. As such, we have adopted this code of conduct and require all those who participate to agree and adhere to these Community Participation Guidelines in order to help us create a safe and positive community experience for all.

These guidelines aim to support a community where all people should feel safe to participate, introduce new ideas and inspire others, regardless of:

- Background
- Family status
- Gender
- Gender identity or expression
- Marital status
- Sex
- Sexual orientation
- Native language
- Age
- Ability
- Race and/or ethnicity
- Caste
- National origin
- Socioeconomic status
- Religion
- Geographic location
- Any other dimension of diversity

Openness, collaboration and participation are core aspects of our work/hobby. We gain strength from diversity and actively seek participation from those who enhance it. These guidelines exist to enable diverse individuals and groups to interact and collaborate to mutual advantage. This document outlines both expected and prohibited behavior.

#### Our Expectations

These guidelines outline our behavior expectations as members of the community in all community activities, both offline and online. Your participation is contingent upon following these guidelines in all community activities, including but not limited to:

- Working in community spaces.
- Working with other community participants virtually or co-located.
- Representing the community at public events.
- Representing the community in social media (official accounts, staff accounts, personal accounts, Facebook pages).
- Participating in community offsites and trainings.
- Participating in community-related forums, mailing lists, wikis, websites, chat channels, bugs, group or person-to-person meetings, and community-related correspondence.

While these guidelines / code of conduct are specifically aimed at community's work, we recognize that it is possible for actions taken outside of community's online or in person spaces to have a deep impact on community health. This is an active topic in the diversity and inclusion realm. We anticipate wide-ranging discussions among our community about appropriate boundaries. 

#### Expected Behavior

The following behaviors are expected of all community participants:

##### Be Respectful

Value each other’s ideas, styles and viewpoints. We may not always agree, but disagreement is no excuse for poor manners. Be open to different possibilities and to being wrong. Be respectful in all interactions and communications, especially when debating the merits of different options. Be aware of your impact and how intense interactions may be affecting people. Be direct, constructive and positive. Take responsibility for your impact and your mistakes – if someone says they have been harmed through your words or actions, listen carefully, apologize sincerely, and correct the behavior going forward. 

##### Be Direct but Professional

We are likely to have some discussions about if and when criticism is respectful and when it’s not. We must be able to speak directly when we disagree and when we think we need to improve. We cannot withhold hard truths. Doing so respectfully is hard, doing so when others don’t seem to be listening is harder, and hearing such comments when one is the recipient can be even harder still. We need to be honest and direct, as well as respectful.

##### Be Inclusive

Seek diverse perspectives. Diversity of views and of people on teams powers innovation, even if it is not always comfortable. Encourage all voices. Help new perspectives be heard and listen actively. If you find yourself dominating a discussion, it is especially important to step back and encourage other voices to join in. Be aware of how much time is taken up by dominant members of the group. Provide alternative ways to contribute or participate when possible.

Be inclusive of everyone in an interaction, respecting and facilitating people’s participation whether they are:

- Remote (on video or phone)
- Not native language speakers
- Coming from a different culture
- Using pronouns other than “he” or “she”
- Living in a different time zone
- Facing other challenges to participate

Think about how you might facilitate alternative ways to contribute or participate. If you find yourself dominating a discussion, step back. Make way for other voices and listen actively to them. 

##### Understand Different Perspectives

Our goal should not be to “win” every disagreement or argument. A more productive goal is to be open to ideas that make our own ideas better. Strive to be an example for inclusive thinking. “Winning” is when different perspectives make our work richer and stronger. 

##### Appreciate and Accommodate Our Similarities and Differences

Community particapants come from many cultures and backgrounds. Cultural differences can encompass everything from official religious observances to personal habits to clothing. Be respectful of people with different cultural practices, attitudes and beliefs. Work to eliminate your own biases, prejudices and discriminatory practices. Think of others’ needs from their point of view. Use preferred titles (including pronouns) and the appropriate tone of voice. Respect people’s right to privacy and confidentiality. Be open to learning from and educating others as well as educating yourself; it is unrealistic to expect community participants to know the cultural practices of every ethnic and cultural group, but everyone needs to recognize one’s native culture is only part of positive interactions. 

##### Lead by Example

By matching your actions with your words, you become a person others want to follow. Your actions influence others to behave and respond in ways that are valuable and appropriate for our community outcomes. Design your community and your work for inclusion. Hold yourself and others accountable for inclusive behaviors. Make decisions based on the highest good for community's mission.

##### Name your sources

In all open source licenses, it is for good reason that the code/images/other intellectual property may only be used and/or modified if the original copyright notice is retained and that the own work must be provided with a copyright notice that makes the work available to the public for free use/modification in accordance with the license you chose. Often, it is also specified in an exemplary or firm manner how the labeling of one’s own work is to be carried out in order for the chosen licence to take effect. Under the GPL, for example, the required labelling looks like this:

```
[one line with the program name and a short description]
Copyright (C) [Year] [Author’s name]

This program is free software: you can redistribute it and/or
modify it under the terms of the [GNU General Public License]([orig-license-url] as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but **without any warranty**; without even the implied warranty of
**merchantability** or **fitness for a particular purpose**.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this program.  If not, see 
<http://www.gnu.org/licenses/>.
```

Unfortunately, it has become common practice for many members of our open source community to ignore all or parts of the license terms of other members of our community. In my experience, they often don't even check what the license terms are. To my great regret, I had to realize that even GitHub doesn't take licenses too seriously (an otherwise great platform, without which the open source community would never have become so popular). As a multi-billion dollar company, which GitHub has rightfully become through popularity, they are unable to recognize and mark up a license that exactly match the conditions by the chosen license (GPLv3 in my case). Simply typing or copying the text of your favorite license (as GitHub does for you when you "select" a license there) does not bind anyone to that text, even if the file is named LICENSE or LICENSE.txt or LICENSE.md. On the contrary, you allow anyone who gets to your sources (which shouldn’t be hard if they’re hosted on GitHub) to do whatever they want with them, since you have nowhere bindingly declared that these terms apply to your work (and legally, no declaration automatically means waiver of your own rights). You did mention somewhere that you think the license is great (otherwise you wouldn't have copied it), but that is legally as effective as saving a picture of Marilyn Monroe in LICENSE because I think she's great (at least in this example). Personally, after publishing Marilyn's picture, I at least don't assume that I'm thereby asserting any legal reservations for my intellectual property, you probably don't either. (If you do, one of us should have urgently professional help from a psychiatrist).

Long story short: I cannot and will not tolerate this behaviour when contributing to this project. Well, of course, I can’t force the open source community to care more about the basics of their own existence, but I can lead by example here as well. I will not accept pull requests where it is not clear whose work served as the basis for your modification and under which conditions / according to which license the use / modification is allowed. Your own work **must** also be provided with a copyright notice in an appropriate form that clearly states the conditions under which **you wish to make your work** available to the open source community for free use/modification (e.g. copyright comment in source code). Since I make this project (as well as all other projects) available for free use / modification according to the GPLv3 license, your license conditions must of course be compatible with the GPL, otherwise I am not allowed to use it (your copyright, where only you decide what is allowed and what is not. I do it with my intellectual property like that. At the moment I can't think of a license where this would not be the case).

I think naming them is the **least** the members of our shared open source community deserve for the hard work they have put in. As **part of this open source community**, we should be **the first** to respect and acknowledge **the intellectual property of our members**. After all, we want at least the members of our community to recognize and respect our intellectual property as such, although (at least I do) also expect the rest of the world to abide by my terms of free use, and I will enforce (hardly imaginable) violations of the license terms in court if necessary. It was not for nothing a long struggle to establish the right to one's own intellectual property (almost) worldwide. If we do not observe our own rules, we cannot expect anyone else to observe our rules. 

So, in short, this is a concretization of the First and Most Important Section about the expected behavior of members of this community: **Be Respectful**, even if your source is not contributing to this project, she/he deserve the same respect as contributors. I, at least, consider myself part of the great open source community, where everyone deserves the same respect, no matter what projects they participate in and in what form.

#### Behavior That Will Not Be Tolerated

The following behaviors are considered to be unacceptable under these guidelines.

##### Violence and Threats of Violence

Violence and threats of violence are not acceptable - online or offline. This includes incitement of violence toward any individual, including encouraging a person to commit self-harm. This also includes posting or threatening to post other people’s personally identifying information (“doxxing”) online. 

##### Personal Attacks

Conflicts will inevitably arise, but frustration should never turn into a personal attack. It is not okay to insult, demean or belittle others. Attacking someone for their opinions, beliefs and ideas is not acceptable. It is important to speak directly when we disagree and when we think we need to improve, but such discussions must be conducted respectfully and professionally, remaining focused on the issue at hand. 

##### Derogatory Language

Hurtful or harmful language related to:

- Background
- Family status
- Gender
- Gender identity or expression
- Marital status
- Sex
- Sexual orientation
- Native language
- Age
- Ability
- Race and/or ethnicity
- Caste
- National origin
- Socioeconomic status
- Religion
- Geographic location
- Other attributes

is not acceptable. This includes deliberately referring to someone by a gender that they do not identify with, and/or questioning the legitimacy of an individual’s gender identity. If you’re unsure if a word is derogatory, don’t use it. This also includes repeated subtle and/or indirect discrimination; when asked to stop, stop the behavior in question. 

##### Unwelcome Sexual Attention or Physical Contact

Unwelcome sexual attention or unwelcome physical contact is not acceptable. This includes sexualized comments, jokes or imagery in interactions, communications or presentation materials, as well as inappropriate touching, groping, or sexual advances. Additionally, touching a person without permission, including sensitive areas such as their hair, pregnant stomach, mobility device (wheelchair, scooter, etc) or tattoos is unacceptable. This includes physically blocking or intimidating another person. Physical contact or simulated physical contact (such as emojis like “kiss”) without affirmative consent is not acceptable. The sharing or distribution of sexualized images or text is unacceptable. 

##### Disruptive Behavior

Sustained disruption of events, forums, or meetings, including talks and presentations, will not be tolerated. This includes:

- ‘Talking over’ or ‘heckling’ speakers.
- Drinking alcohol to excess or using recreational drugs to excess, or pushing others to do so.
- Making derogatory comments about those who abstain from alcohol or other substances, pushing people to drink, talking about their abstinence or preferences to others, or pressuring them to drink - physically or through jeering.
- Otherwise influencing crowd actions that cause hostility in the session.

##### Influencing Unacceptable Behavior

We will treat influencing or leading such activities the same way we treat the activities themselves, and thus the same consequences apply. 

#### Consequences of Unacceptable Behavior

 Bad behavior from any community participant, including those with decision-making authority, will not be tolerated. Intentional efforts to exclude people (except as part of a consequence of the guidelines or other official action) from community activities are not acceptable and will be dealt with appropriately.

Reports of harassment/discrimination will be promptly and thoroughly investigated by the people responsible for the safety of the space, event or activity. Appropriate measures will be taken to address the situation.

Anyone being asked to stop unacceptable behavior is expected to comply immediately. Violation of these guidelines can result in anyone being asked to leave an event or online space, either temporarily or for the duration of the event, or being banned from participation in spaces, or future events and activities in perpetuity.

In addition, any participants who abuse the reporting process will be considered to be in violation of these guidelines and subject to the same consequences. False reporting, especially to retaliate or exclude, will not be accepted or tolerated. 

#### Reporting of Unacceptable Behaviour

If you believe you’re experiencing unacceptable behavior that will not be tolerated as outlined above, please use <coc-report@nixe-home.de> to report. Reports are triaged by the Community Participation Guidelines Response Lead.

After receiving a concise description of your situation, they will review and determine the next steps. In addition to conducting an investigation, they can provide a range of resources to help you to get the inacceptable behavior stopped - from one-on-one counseling to community resources. In consultation with you they will involve community participant or outside experts (such as legal counsel) who are appropriate and necessary for the situation.

Additional Resources: How to Report<br/>
Questions: <coc-questions@nixe-home.de>

Please also report to us if you observe a potentially dangerous situation, someone in distress, or violations of these guidelines, even if the situation is not happening to you.

If you feel you have been unfairly accused of violating these guidelines, please follow the same reporting process. 

#### Community Spaces

Each physical or virtual community space shall have a designated contact. 

#### Community Events

 All community events will have designated a specific safety guideline with emergency and anti-abuse contacts at the event as well as online. These contacts will be posted prominently throughout the event, and in print and online materials. Event leaders are requested to speak at the event about the guidelines and to ask participants to review and agree to them when they sign up for the event.

Reports will receive an email notice of receipt. Once an incident has been investigated and a decision has been communicated to the relevant parties, all have the opportunity to appeal this decision by sending an email to <coc-questions@nixe-home.de>. 

#### Ask Questions

Everyone is encouraged to ask questions about these guidelines. If you are organizing an event or activity, reach out for tips for building inclusion for your event, activity or space. Your input is welcome and you will always get a response within 24 hours (or on the next weekday, if it is the weekend) if you reach out to <coc-questions@nixe-home.de>.

### Copyright and Attribution

These guidelines are published under the [Creative Commons Attribution-ShareAlike license][license-url]. 

They have been adapted with modifications from Mozilla’s original Community Participation Guidelines, the Ubuntu Code of Conduct, Mozilla’s View Source Conference Code of Conduct, and the Rust Language Code of Conduct, which are based on Stumptown Syndicate’s Citizen Code of Conduct. Additional text from the LGBTQ in Technology Code of Conduct and the WisCon code of conduct.

Mozilla’s guidelines for community engagement were my inspiration, and I have essentially adopted them unchanged.<br/>
Version 3.1 - Updated on January 16, 2020<br/>
<https://www.mozilla.org/en/about/governance/policies/participation/>

You can find answers to the most frequently asked questions in the FAQ below
<https://www.contributor-covenant.org/faq>.

### Modifications to these Guidelines

Community Participation Guidelines Response Lead may amend the guidelines from time to time and may also vary the procedures it sets out where appropriate in a particular case. Your agreement to comply with the guidelines will be deemed agreement to any changes to it. 

<!-- MARKDOWN LINKS & IMAGES -->
<!-- https://www.markdownguide.org/basic-syntax/#reference-style-links -->

[logo]: images/logo.svg
[project-url]: https://github.com/nixe64/The-Next-Generation/

[license-badge]: images/license.cc-by-sa.en.svg
[license-url]: License.cc-by-sa.en.md

[version-badge]: images/version.svg
[version-url]: https://github.com/nixe64/The-Next-Generation/releases

[issues-url]: https://github.com/nixe64/The-Next-Generation/issues
[bugs-badge]: https://img.shields.io/github/issues/nixe64/the-next-generation/bug.svg?label=Fehlerberichte&color=informational
[bugs-url]: https://github.com/nixe64/The-Next-Generation/issues?utf8=✓&q=is%3Aissue+is%3Aopen+label%3Abug
