<a href="CONTRIBUTING.en.md"><img src="images/en.svg" valign="top" align="right"/></a>
<a href="CONTRIBUTING.md"><img src="images/de.svg" valign="top" align="right"/></a>
<!--[![Version][version-badge]][version-url]-->
[![License][license-badge]][license-url]
<!--
[![Bugs][bugs-badge]][bugs-url]
-->

[![Logo][logo]][project-url]

### Feature Suggestions, Bug Reports and Translations

If you want to suggest a new feature or if you've found a bug, please open a new [issue][issues-url] on GitHub.

But, **please verify** that you are the first to suggest this feature or to report the bug. Thank you!
<br/>

### Contributions to the project

Everybody is invited and welcome to contribute to this project. There is a lot to do...<br/>
The process is straightforward.

- Read the [license agreement][cla-url] and the [code of conduct][coc-url] for contributors. If you agree with the agreements, then....
- Read [How to get faster PR reviews][pr-reviews] of Kubernetes, then...
 - Fork this project on GitHub.
 - Check out the **develop** branch before you start development.
  That way, you'll already have the latest features that are still under development in your code. But you can also
  with the latest stable version, which git will do for you automatically.
 - Create a new branch for your work. Commits to the **master** and **develop** branches are **not allowed**. Personally, I recommend using **[GitHub Flow][flow-url]**, but it's not required.
 - Write your code and add new tests for your implementation if possible. Changes to the original tests are **not allowed** unless the test itself has a bug or is incomplete.
 - Make sure your code works locally and, if available, that the tests do not find bugs.
 - Create a [pull request][pr-url] for the **develop** branch.

Translators who can improve existing translations or who want to contribute new ones are also welcome. I will not make translations to languages that I do not (at least rudimentarily) speak and/or understand myself. This is the better solution for all sides! Machine translations would not be helpful. Unfortunately, the technology is not yet mature enough to be able to use the translations (except for a personal encounter, where hands and feet are also available).

Still interested? **Great, welcome to the team!**

<!-- MARKDOWN LINKS & IMAGES -->
<!-- https://www.markdownguide.org/basic-syntax/#reference-style-links -->

[logo]: images/logo.svg
[project-url]: https://github.com/nixe64/The-Next-Generation

[license-badge]: images/license.cc-by-sa.en.svg
[license-url]: ../COPYRIGHT.en.md

[version-badge]: images/version.svg
[version-url]: https://github.com/nixe64/The-Next-Generation/releases

[issues-url]: https://github.com/nixe64/The-Next-Generation/issues
[bugs-badge]: https://img.shields.io/github/issues/nixe64/the-next-generation/bug.svg?label=Fehlerberichte&color=informational
[bugs-url]: https://github.com/nixe64/The-Next-Generation/issues?utf8=✓&q=is%3Aissue+is%3Aopen+label%3Abug

[coc-url]: CODE_OF_CONDUCT.en.md
[pr-reviews]: https://github.com/kubernetes/community/blob/master/contributors/guide/pull-requests.md#best-practices-for-faster-reviews
[cla-url]: contributing/CLA.en.md
[flow-url]: https://githubflow.github.io/
[pr-url]: https://github.com/nixe64/The-Next-Generation/pulls
