<a href="CONTRIBUTING.en.md"><img src="images/en.svg" valign="top" align="right"/></a>
<a href="CONTRIBUTING.md"><img src="images/de.svg" valign="top" align="right"/></a>
<!--[![Version][version-badge]][version-url]-->
[![License][license-badge]][license-url]
<!--
[![Bugs][bugs-badge]][bugs-url]
-->

[![Logo][logo]][project-url]

### Verbesserungsvorschläge, Fehlerberichte und Übersetzungen

Wenn du einen Verbesserungsvorschlag hast oder einen Fehler melden möchtest, eröffne einfach ein neues [Issue][issues-url] auf GitHub.

Aber **bitte überprüfe**, daß du die/der Erste bist, die/der die Verbesserung vorschlägt oder diesen Fehler meldet. Vielen Dank!
<br/>

### Mitwirkung an diesem Projekt

Jeder ist eingeladen und willkommen, sich an diesem Projekt zu beteiligen. Es gibt viel zu tun...<br/>
Der Prozess ist unkompliziert.

- Lies die [Lizenzverbarung][cla-url] und den [Verhaltenscodex][coc-url] für Mitwirkende. Wenn du mit den Vereinbarungen einverstanden bist, dann...
- Lies [So erhälst du schnellere PR-Reviews][pr-reviews] von Kubernetes, dann...
 - Forke dieses Projekt auf GitHub.
 - Checke den Branch **develop** aus, bevor du mit der Entwicklung beginnst.
  Auf diese Weise hast du bereits die neuesten Funktionen, die sich noch in der Entwicklung befinden, in deinem Code. Aber du kannst auch
  mit der letzten stabilen Version starten, was git automatisch für dich macht.
 - Erstelle einen neuen Branch für deine Arbeit. Commits in die Branches **master** und **develop** sind **nicht gestattet**. Persönlich empfehle ich die Verwendung von **[GitHub Flow][flow-url]**, aber es ist nicht erforderlich.
 - Schreibe deinen Code und füge nach Möglichkeit neue Tests für deine Implementierung hinzu. Änderungen an den ursprünglichen Tests sind **nicht gestattet**, außer wenn der Test selbst einen Bug hat oder unvollständig ist.
 - Stelle sicher, dass dein Code lokal funktioniert und, falls verfügbar, die Tests keine Fehler finden.
 - Erstelle einen [Pull-Request][pr-url] für den Branch **develop**.

Ebenfalls gern gesehen wären Übersetzer, die entwder die vorhanden Übersetzungen verbessern können oder neue Übersetzungen beitragen möchten. Ich werde keine Übersetzungen in Sprachen anfertigen, die ich nicht (zumindest rudimentär) auch selber spreche und/oder verstehe. Das ist für alle Seiten die bessere Lösung! Nicht hilfreich wären dabei maschinelle Übersetzungen. Leider ist die Technik noch nicht ausgereift genug, um die Übersetzungen auch verwenden zu können (außer bei einer persönlichen Begegnung, wo zusätzlich auch noch Hände und Füsse zur Verfügung stehen).

Noch interessiert? **Super, herzlich willkommen im Team!**

<!-- MARKDOWN LINKS & IMAGES -->
<!-- https://www.markdownguide.org/basic-syntax/#reference-style-links -->

[logo]: images/logo.svg
[project-url]: https://github.com/nixe64/The-Next-Generation

[license-badge]: images/license.de.svg
[license-url]: ../COPYRIGHT.de.md

[version-badge]: images/version.svg
[version-url]: https://github.com/nixe64/the-next-generation/releases

[issues-url]: https://github.com/nixe64/the-next-generation/issues
[bugs-badge]: https://img.shields.io/github/issues/nixe64/the-next-generation/bug.svg?label=Fehlerberichte&color=informational
[bugs-url]: https://github.com/nixe64/the-next-generation/issues?utf8=✓&q=is%3Aissue+is%3Aopen+label%3Abug

[coc-url]: CODE_OF_CONDUCT.md
[pr-reviews]: https://github.com/kubernetes/community/blob/master/contributors/guide/pull-requests.md#best-practices-for-faster-reviews
[cla-url]: contributing/CLA.de.md
[flow-url]: https://githubflow.github.io/
[pr-url]: https://github.com/nixe64/The-Next-Generation/pulls
